// LONG_SMPLDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "LONG_SMPL.h"
#include "LONG_SMPLDlg.h"
#include "TUSADSMS.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLONG_SMPLDlg _CAO

CLONG_SMPLDlg::CLONG_SMPLDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLONG_SMPLDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLONG_SMPLDlg)
	m_IdSel = -1;
	m_TriggerTypeSel = -1;
	m_TriggerLevel = 0;
	m_TriggerCh = -1;
	m_ClockInterval = 0;
	m_PreTriggerLen = 0;
	m_LimitLen = 0;
	m_ClkSel = -1;
	m_StatusView = _T("");
	//}}AFX_DATA_INIT
	for( int ch = 0 ; ch < 16 ; ch++ )
	{
		m_ChChk[ch] = FALSE;
		m_RangeSel[ch] = 0;
	}
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLONG_SMPLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLONG_SMPLDlg)
	DDX_CBIndex(pDX, IDC_IDSEL, m_IdSel);
	DDX_CBIndex(pDX, IDC_TRIGGERTYPESEL, m_TriggerTypeSel);
	DDX_Text(pDX, IDC_TRIGGERLEVEL, m_TriggerLevel);
	DDV_MinMaxUInt(pDX, m_TriggerLevel, 1, 4094);
	DDX_CBIndex(pDX, IDC_TRIGGERCH, m_TriggerCh);
	DDX_Text(pDX, IDC_CLOCKINTERVAL, m_ClockInterval);
	DDV_MinMaxInt(pDX, m_ClockInterval, 10, 16777215);
	DDX_Text(pDX, IDC_PRETRIGGERLEN, m_PreTriggerLen);
	DDV_MinMaxInt(pDX, m_PreTriggerLen, 0, 10000000);
	DDX_Text(pDX, IDC_LIMITLEN, m_LimitLen);
	DDX_Radio(pDX, IDC_CLKSEL1, m_ClkSel);
	DDX_Text(pDX, IDC_STATUSVIEW, m_StatusView);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_CH_CHK1, m_ChChk[0]);
	DDX_Check(pDX, IDC_CH_CHK2, m_ChChk[1]);
	DDX_Check(pDX, IDC_CH_CHK3, m_ChChk[2]);
	DDX_Check(pDX, IDC_CH_CHK4, m_ChChk[3]);
	DDX_Check(pDX, IDC_CH_CHK5, m_ChChk[4]);
	DDX_Check(pDX, IDC_CH_CHK6, m_ChChk[5]);
	DDX_Check(pDX, IDC_CH_CHK7, m_ChChk[6]);
	DDX_Check(pDX, IDC_CH_CHK8, m_ChChk[7]);
	DDX_Check(pDX, IDC_CH_CHK9, m_ChChk[8]);
	DDX_Check(pDX, IDC_CH_CHK10, m_ChChk[9]);
	DDX_Check(pDX, IDC_CH_CHK11, m_ChChk[10]);
	DDX_Check(pDX, IDC_CH_CHK12, m_ChChk[11]);
	DDX_Check(pDX, IDC_CH_CHK13, m_ChChk[12]);
	DDX_Check(pDX, IDC_CH_CHK14, m_ChChk[13]);
	DDX_Check(pDX, IDC_CH_CHK15, m_ChChk[14]);
	DDX_Check(pDX, IDC_CH_CHK16, m_ChChk[15]);

	DDX_CBIndex(pDX, IDC_RANGE_SEL1, m_RangeSel[0]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL2, m_RangeSel[1]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL3, m_RangeSel[2]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL4, m_RangeSel[3]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL5, m_RangeSel[4]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL6, m_RangeSel[5]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL7, m_RangeSel[6]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL8, m_RangeSel[7]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL9, m_RangeSel[8]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL10, m_RangeSel[9]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL11, m_RangeSel[10]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL12, m_RangeSel[11]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL13, m_RangeSel[12]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL14, m_RangeSel[13]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL15, m_RangeSel[14]);
	DDX_CBIndex(pDX, IDC_RANGE_SEL16, m_RangeSel[15]);
}

BEGIN_MESSAGE_MAP(CLONG_SMPLDlg, CDialog)
	//{{AFX_MSG_MAP(CLONG_SMPLDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_OPEN, OnOpenBtn)
	ON_BN_CLICKED(IDC_CLOSE, OnCloseBtn)
	ON_BN_CLICKED(IDC_START, OnStartBtn)
	ON_BN_CLICKED(IDC_STOP, OnStopBtn)
	ON_BN_CLICKED(IDC_TRIGGER, OnTriggerBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLONG_SMPLDlg bZ[W nh

BOOL CLONG_SMPLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	DialogInit();
	EnableDisableControl(0);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CLONG_SMPLDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CLONG_SMPLDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//ʕ\̏
void CLONG_SMPLDlg::DialogInit()
{
	m_IdSel = 0;
	m_TriggerTypeSel = 0;
	m_TriggerLevel = 2048;
	m_TriggerCh = 0;
	m_ClkSel = 0;
	m_ClockInterval = 1000;
	m_PreTriggerLen = 0;
	m_LimitLen = 100;

	UpdateData(FALSE);
}

//ʏRg[̕\ԕύX
void CLONG_SMPLDlg::EnableDisableControl(int sel)
{
	UpdateData(TRUE);
	switch( sel )
	{
	case 0://I[vĂȂ
		GetDlgItem(IDC_OPEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
		GetDlgItem(IDC_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDSEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGER)->EnableWindow(FALSE);

		break;
	case 1://I[vĂ(ҋ@)
		GetDlgItem(IDC_OPEN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLOSE)->EnableWindow(TRUE);
		GetDlgItem(IDC_START)->EnableWindow(TRUE);
		GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
		GetDlgItem(IDC_IDSEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_CH_CHK1)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK2)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK3)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK4)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK5)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK6)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK7)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK8)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK9)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK10)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK11)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK12)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK13)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK14)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK15)->EnableWindow(TRUE);
		GetDlgItem(IDC_CH_CHK16)->EnableWindow(TRUE);

		GetDlgItem(IDC_RANGE_SEL1)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL2)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL3)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL4)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL5)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL6)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL7)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL8)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL9)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL10)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL11)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL12)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL13)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL14)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL15)->EnableWindow(TRUE);
		GetDlgItem(IDC_RANGE_SEL16)->EnableWindow(TRUE);

		GetDlgItem(IDC_TRIGGERTYPESEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGERLEVEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGERCH)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLKSEL1)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLKSEL2)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLOCKINTERVAL)->EnableWindow(TRUE);
		GetDlgItem(IDC_PRETRIGGERLEN)->EnableWindow(TRUE);
		GetDlgItem(IDC_LIMITLEN)->EnableWindow(TRUE);
		break;
	case 2://I[vĂ(TvO)
		GetDlgItem(IDC_OPEN)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
		GetDlgItem(IDC_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
		GetDlgItem(IDC_IDSEL)->EnableWindow(FALSE);
		if(m_TriggerTypeSel == 0)
			GetDlgItem(IDC_TRIGGER)->EnableWindow(TRUE);
		else
			GetDlgItem(IDC_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_CH_CHK1)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK2)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK3)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK4)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK5)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK6)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK7)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK8)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK9)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK10)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK11)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK12)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK13)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK14)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK15)->EnableWindow(FALSE);
		GetDlgItem(IDC_CH_CHK16)->EnableWindow(FALSE);

		GetDlgItem(IDC_RANGE_SEL1)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL2)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL3)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL4)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL5)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL6)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL7)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL8)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL9)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL10)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL11)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL12)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL13)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL14)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL15)->EnableWindow(FALSE);
		GetDlgItem(IDC_RANGE_SEL16)->EnableWindow(FALSE);

		GetDlgItem(IDC_TRIGGERTYPESEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGERLEVEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGERCH)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLKSEL1)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLKSEL2)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLOCKINTERVAL)->EnableWindow(FALSE);
		GetDlgItem(IDC_PRETRIGGERLEN)->EnableWindow(FALSE);
		GetDlgItem(IDC_LIMITLEN)->EnableWindow(FALSE);
		break;
	}
}

//foCXI[v{^
void CLONG_SMPLDlg::OnOpenBtn() 
{
	short ret;

	UpdateData(TRUE);
	ret = Tusbadsms_Device_Open(m_IdSel);
	if( ret )
	{
		ErrDisp(ret);
	}
	else
	{
		EnableDisableControl(1);
		m_StatusView = "I[v܂";
		UpdateData(FALSE);
	}	
}

//G[bZ[W\
void CLONG_SMPLDlg::ErrDisp(short errcode)
{
	switch( errcode )
	{
	case 0:
		AfxMessageBox("");
		break;
	case 1:
		AfxMessageBox("IDԍsł");
		break;
	case 2:
		AfxMessageBox("hCoCXg[Ă܂");
		break;
	case 3:
		AfxMessageBox("̃foCX͂łɃI[vĂ܂");
		break;
	case 4:
		AfxMessageBox("foCXI[vł܂");
		break;
	case 5:
		AfxMessageBox("foCX̐ڑ䐔܂");
		break;
	case 6:
		AfxMessageBox("foCX܂");
		break;
	case 7:
		AfxMessageBox("̃foCX̓I[vĂ܂");
		break;
	case 8:
		AfxMessageBox("sł");
		break;
	case 9:
		AfxMessageBox("USB̒ʐMG[ł");
		break;
	case 10:
		AfxMessageBox("̈悪mۂł܂");
		break;
	case 11:
		AfxMessageBox("A荞ݓ쒆ł");
		break;
	case 12:
		AfxMessageBox("A荞ݍς݃f[^͂܂");
		break;
	case 99:
		AfxMessageBox("̑̃G[ł");
		break;
 	default:
		AfxMessageBox("sȃG[ł");
		break;
	}
}

//f[^dlւ̕ϊ
float CLONG_SMPLDlg::RawToVolt(short dat, BYTE range)
{
	switch( range )
	{
	case 0://}10VW
		return(float)( dat / 4096.0 * 20.0 - 10.0);
	case 1://}5VW
		return(float)( dat / 4096.0 * 10.0 - 5.0);
	case 2://}2.5VW
		return(float)( dat / 4096.0 * 5.0 - 2.5);
	case 3://}1VW
		return(float)( dat / 4096.0 * 2.0 - 1.0);
	case 4://}0.5VW
		return(float)( dat / 4096.0 * 1.0 - 0.5);
	case 5://}0.25VW
		return(float)( dat / 4096.0 * 0.5 - 0.25);
	case 6://}0.1VW
		return(float)( dat / 4096.0 * 0.2 - 0.1);
	case 7://10VW
		return(float)( dat / 4096.0 * 10.0);
	case 8://5VW
		return(float)( dat / 4096.0 * 5.0);
    case 9://2.5VW
		return(float)( dat / 4096.0 * 2.5);
	case 10://1VW
		return(float)( dat / 4096.0 * 1.0);
	case 11://0.5VW
		return(float)( dat / 4096.0 * 0.5);
	case 12://0.25VW
		return(float)( dat / 4096.0 * 0.25);
	case 13://0.1VW
		return(float)( dat / 4096.0 * 0.1);
    default:
		return( 0.0);
	}
}

//foCXN[Y{^
void CLONG_SMPLDlg::OnCloseBtn() 
{
    Tusbadsms_Device_Close (m_IdSel);
    //Cl[ufBZ[u
    EnableDisableControl(0);
	m_StatusView = "foCXI[vĂ܂";
	UpdateData(FALSE);
}

//TvOJn{^
void CLONG_SMPLDlg::OnStartBtn() 
{
	int ch;
	short ret;

	if( !UpdateData(TRUE) )
		return;//͒lG[

	smpl_setting.ChLen = 0;
	for( ch = 0 ; ch < 16 ; ch++ )
	{
		if( m_ChChk[ch] )
		{
			smpl_setting.ChPattern[smpl_setting.ChLen] = ch;
			smpl_setting.ChPatternRange[smpl_setting.ChLen] = m_RangeSel[ch];
			smpl_setting.ChLen++;
		}
	}
	if( smpl_setting.ChLen == 0 )
	{
		AfxMessageBox("`lIĂ܂");
		return;
	}

	smpl_setting.TriggerType = m_TriggerTypeSel + 1;
	if( smpl_setting.TriggerType >= 3 )
	{
		smpl_setting.TriggerLevel = m_TriggerLevel;
	}

	smpl_setting.ClockSel = m_ClkSel;
	if( smpl_setting.ClockSel == 0 )
		smpl_setting.SamplingClock = m_ClockInterval;

	smpl_setting.PreTriggerLen = m_PreTriggerLen;

	smpl_setting.TotalLen = 1000000;



	CFileDialog fileDlg(FALSE,"dat","*.dat",
		OFN_OVERWRITEPROMPT | OFN_NOREADONLYRETURN | OFN_EXPLORER,
		"f[^t@C(*.dat)|*.dat");
	CFileException e;
	if( fileDlg.DoModal() == IDOK )
	{
		p_SaveFile = fopen(fileDlg.GetPathName(),"w");
		if( ! p_SaveFile )
		{
			AfxMessageBox("t@CI[vG[");
			return;
		}
	}

	SamplingBuffer = new short[smpl_setting.ChLen*m_LimitLen];
	if( SamplingBuffer == NULL )
	{
		AfxMessageBox("ƃ̈悪mۂł܂");
		return;
	}

	ret = Tusbadsms_Sample_Start(m_IdSel,&smpl_setting);

	if( ret == 0 )//ɃX^[g
	{
		StopReq = FALSE;
		TotalLeng = 0;
		SaveLeng = m_LimitLen;
		EnableDisableControl(2);
		SetTimer(0,200,NULL);
	}
	else//ɃX^[głȂ
	{
		fclose(p_SaveFile);
		delete [] SamplingBuffer;
		ErrDisp(ret);
	}
}

//TvO~{^
void CLONG_SMPLDlg::OnStopBtn() 
{
	StopReq = TRUE;
}

//^C}[
void CLONG_SMPLDlg::OnTimer(UINT nIDEvent) 
{
	short ret;
	char status;
	char ovf;
	int leng,buflen;
	short *tmpData;

	KillTimer(nIDEvent);
	if( StopReq )//~v(STOP{^)̊mF
	{
		SampleStop();
		m_StatusView.Format("TvOI\nf[^%d",TotalLeng);
	}
	else
	{
		ret = Tusbadsms_Status_Read(m_IdSel, &status, &ovf, &leng);
		if( ret )
		{
			ErrDisp(ret);
			SampleStop();
		}
		else
		{
			switch( status )
			{
			case 0://~
				m_StatusView = "~ł";
				SetTimer(nIDEvent,200,NULL);
				break;
			case 1://gK҂
				m_StatusView = "gK҂ł";
				SetTimer(nIDEvent,200,NULL);
				break;
			case 2://TvO
				if( ovf )//I[o[t[̎
				{
					AfxMessageBox("obt@I[o[t[ł");
					SampleStop();
					break;
				}
				tmpLeng = leng;
				if( ( TotalLeng + tmpLeng ) >= SaveLeng )//ő荞ݒ𒴂Ă
				{
					leng = SaveLeng - TotalLeng;
					buflen = leng;
					tmpData = new short[buflen * smpl_setting.ChLen];
					if( tmpData == NULL )
					{
						AfxMessageBox("ƃ̈悪mۂł܂");
						SampleStop();
						break;
					}
					ret =  Tusbadsms_Memory_Read(m_IdSel, tmpData, &leng);//f[^̓ǂݍ
					CopyData(tmpData,leng,buflen);
					TotalLeng += leng;
					SampleStop();
					m_StatusView.Format("TvOI\nf[^ = %d",TotalLeng);
					delete [] tmpData;
				}
				else
				{
					buflen = leng;
					tmpData = new short[buflen * smpl_setting.ChLen];
					if( tmpData == NULL )
					{
						AfxMessageBox("ƃ̈悪mۂł܂");
						SampleStop();
						break;
					}
					ret =  Tusbadsms_Memory_Read(m_IdSel, tmpData, &leng);//f[^̓ǂݍ
					CopyData(tmpData,leng,buflen);
					TotalLeng += leng;
					m_StatusView.Format("TvOł\nf[^ = %d",TotalLeng);
					SetTimer(nIDEvent,200,NULL);
					delete [] tmpData;
				}
			}
		}
	}

	UpdateData(FALSE);

	CDialog::OnTimer(nIDEvent);
}

//A荞ݒ~̏
void CLONG_SMPLDlg::SampleStop()
{
    Tusbadsms_Sampling_Stop(m_IdSel);//TvO~
	m_StatusView = "f[^ۑ";
	UpdateData(FALSE);
	WriteData();
	delete [] SamplingBuffer;
    EnableDisableControl(1);
	fclose(p_SaveFile);
}

//f[^̃Rs[
void CLONG_SMPLDlg::CopyData(short *data, UINT len, UINT buflen)
{
	int ch;

	for( ch = 0 ; ch < smpl_setting.ChLen ; ch++ )
	{
		memcpy( &SamplingBuffer[ch * SaveLeng + TotalLeng],&data[ch * buflen],len * sizeof(short));
	}
}

//f[^̏ݏ
void CLONG_SMPLDlg::WriteData(void)
{
	UINT cnt,pos;
	int ch;

	for( cnt = 0 ; cnt < TotalLeng ; cnt++ )
	{
		pos = cnt;
		for( ch = 0 ; ch < smpl_setting.ChLen ; ch++ )
		{
			fprintf(p_SaveFile,"%d",SamplingBuffer[pos]);
			if( ch == ( smpl_setting.ChLen - 1 ) )
				fputs("\n",p_SaveFile);
			else
				fputs(",",p_SaveFile);
			pos += SaveLeng;
		}
	}
}

//\tgEFAgK{^
void CLONG_SMPLDlg::OnTriggerBtn() 
{
	short ret;

    ret = Tusbadsms_Sampling_Trigger(m_IdSel);//gKR}h
    if(ret)
	{
        ErrDisp(ret);
        StopReq = TRUE;
	}
}
